/*
 * Decimal.java	2002/10/29 writen by Takefumi Yokoyama
 *
 * Copyright  All Rights Reserved.
 *
*/
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math ;

public class Decimal {
  long v=0;
  int  dp=0,len=0, zfg=0, kfg=0;
  static final long[] pow10={1L,10L,100L,1000L,
                             10000L,
                             100000L,
                             1000000L,
                             10000000L,
                             100000000L,
                             1000000000L,
                             10000000000L  };
  public Decimal(){
      this.len=10;
  }

  public Decimal( int dp ){
      this.dp=dp;
      this.len=10;
  }

  public Decimal( String frm ) {
      this.len=frm.length();
      int pp=frm.indexOf(".");
      if(pp>=0)  dp=this.len-pp-1;
      pp=frm.indexOf(",");
      if(pp>=0)  kfg=1;
      pp=frm.indexOf("z");
      if(pp>=0)  zfg=1;
  }

  public static Decimal set( int a ){
      Decimal aw=new Decimal();
      aw.v=a; aw.dp=0;
      return aw;
  }

  public static Decimal set( long a ){
      Decimal aw=new Decimal();
      aw.v=a; aw.dp=0;
      return aw;
  }

  public static Decimal set( String a ){
      int pp=a.indexOf(".");
      Decimal aw=new Decimal();
      if(pp<0){
          aw.v=Integer.parseInt(a);
      }else{
          String w1=a.substring(0,pp);
          String w2=a.substring(pp+1);
          aw.v=Integer.parseInt(w1+w2);
          aw.dp=w2.length();
      }
      return aw;
  }

  public static void move( int a, Decimal b){
      Decimal aw=set( a );
      move( aw, b);
  }

  public static void move( long a, Decimal b){
      Decimal aw=set( a );
      move( aw, b);
  }

  public static void move( double a, Decimal b){
      b.v=(long)(a*pow10[b.dp]);
  }

  public static void move( String a, Decimal b ){
      Decimal aw=set( a );
      move( aw, b );
  }

  public static void move( Decimal a, Decimal b ){
      b.v = a.v;
      int n=b.dp-a.dp;
      if( n>0 ){
           b.v *=pow10[n];
      }
      if( n<0 ){
           b.v /=pow10[-n];
      }
 //     System.out.println("move v="+a.v+" "+b.v);
 //     System.out.println("move dp="+a.dp+" "+b.dp);
  }

  public static void add( int a, Decimal b){
      Decimal aw=set( a );
      add( aw, b);
  }

  public static void add( String a, Decimal b ){
      Decimal aw=set( a );
      add( aw, b );
  }

  public static void add( Decimal a, Decimal b ){
       Decimal aw=new Decimal( b.dp );
       move( a, aw );
       b.v += aw.v;
  }

    public static void sub( int a, Decimal b){
      Decimal aw=set( a );
      sub( aw, b);
  }

  public static void sub( String a, Decimal b ){
      Decimal aw=set( a );
      sub( aw, b );
  }

  public static void sub( Decimal a, Decimal b ){
       Decimal aw=new Decimal( b.dp );
       move( a, aw );
       b.v -= aw.v;
  }

  public static void mul( int a, Decimal b, Decimal c ){
      Decimal aw=set( a );
      mul( aw, b, c);
  }

  public static void mul( String a, Decimal b, Decimal c ){
      Decimal aw=set( a );
      mul( aw, b, c );
  }

  public static void mul( Decimal a, Decimal b, Decimal c  ){
      c.v = a.v*b.v;
      if( (a.dp+b.dp)>c.dp) c.v /= pow10[a.dp+b.dp-c.dp];
      else   c.v *= pow10[c.dp-a.dp-b.dp];
   System.out.println("mul v="+a.v+" "+b.v+" "+c.v);
   System.out.println("mul dp="+a.dp+" "+b.dp+" "+c.dp);
  }

  public static void div( Decimal a,int b, Decimal c){
      Decimal bw=set( b );
      div( a, bw, c);
  }

  public static void div(  Decimal a,String b, Decimal c ){
      Decimal bw=set( b );
      div(a, bw, c );
  }

  public static void div( Decimal a, Decimal b, Decimal c ){
      Decimal aw = new Decimal( a.dp);
      aw.v=a.v;
      if( (c.dp+b.dp)>a.dp)  aw.v *= pow10[c.dp+b.dp-a.dp];
      c.v = aw.v/b.v;
      if( a.dp>(c.dp+b.dp) )  c.v /= pow10[a.dp-c.dp-b.dp];

      System.out.println("div v="+a.v+" "+b.v+" "+c.v);
      System.out.println("div dp="+a.dp+" "+b.dp+" "+c.dp);
  }

  public static void pow( Decimal b, int n, Decimal c){
      move( 1, c );
      Decimal pw=new Decimal( c.dp );
      move( b, pw );
      while( n != 0 ){
          if( (n&1)==1 ) mul( pw, c, c );
          mul( pw, pw, pw );
          n >>>= 1;
      }
  }


  public static String getS( Decimal a ){
      String mw=""+a.v;
      int wl=mw.length();
      if( wl<a.dp){
          mw="0000000000".substring(0,a.dp-wl+1)+mw;
          wl=a.dp+1;
      }
      String w1=mw.substring(0,wl-a.dp);
      String w2=mw.substring(wl-a.dp);
      if( a.kfg>0 ){
          int fw=w1.length()%3;
          w1="   ".substring(0,3-fw)+w1;
          String ww="";
          for( int j=0; j<w1.length(); j+=3){
 //     System.out.println("ww="+ww+"w1="+w1);
               ww += w1.substring(j,j+3)+",";
          }
          w1=ww.substring(3-fw, ww.length()-1);
      }
      if( a.dp!=0 )    mw=w1+'.'+w2;
      String dw="";
      if( a.zfg>0 ) dw="                    ";
      else          dw="00000000000000000000";
      mw=dw.substring(0,a.len-mw.length())+mw;
      return mw;
  }

  public static void main(String[] args) {
    Decimal dec1 = new Decimal("999999999.000");
    Decimal dec2 = new Decimal("999999999");
    Decimal dec3 = new Decimal("999999999.0000");
    Decimal.move( 0.05 , dec1 );
    Decimal.move( 12 , dec2 );
    Decimal.div(dec1,dec2,dec3 );

    System.out.println( Decimal.getS( dec3) );

//    System.out.println( ""+Math.pow(3,8));
  }

}